Index: moodle/lib/navigationlib.php
--- moodle/lib/navigationlib.php Base (1.86)
+++ moodle/lib/navigationlib.php Locally Modified (Based On 1.86)
@@ -190,654 +169,553 @@
             if (array_key_exists('key', $properties)) {
                 $this->key = $properties['key'];
             }
+            if (array_key_exists('parent', $properties)) {
+                $this->parent = $properties['parent'];
+            }
+            // This needs to happen last because of the check_if_active call that occurs
+            if (array_key_exists('action', $properties)) {
+                $this->action = $properties['action'];
+                if (is_string($this->action)) {
+                    $this->action = new moodle_url($this->action);
+                }
+                if (self::$autofindactive) {
+                    $this->check_if_active();
+                }
+            }
         } else if (is_string($properties)) {
             $this->text = $properties;
         }
         if ($this->text === null) {
             throw new coding_exception('You must set the text for the node when you create it.');
         }
+        // Default the title to the text
         $this->title = $this->text;
         $textlib = textlib_get_instance();
         if (strlen($this->text)>50) {
+            // Truncate the text to 50 characters
             $this->text = $textlib->substr($this->text, 0, 50).'...';
         }
         if (is_string($this->shorttext) && strlen($this->shorttext)>25) {
+            // Truncate the shorttext
             $this->shorttext = $textlib->substr($this->shorttext, 0, 25).'...';
         }
+        // Instantiate a new navigation node collection for this nodes children
+        $this->children = new navigation_node_collection();
     }
 
     /**
-     * This function overrides the active URL that is used to compare new nodes
-     * to find out if they are active.
+     * Checks if this node is the active node.
      *
-     * If null is passed then $fullmeurl will be regenerated when the next node
-     * is created/added
-     */
-    public static function override_active_url(moodle_url $url=null) {
-        self::$fullmeurl = $url;
-    }
-
-    /**
-     * This function checks if the node is the active child by comparing its action
-     * to the current page URL obtained via $PAGE->url
+     * This is determined by comparing the action for the node against the
+     * defined URL for the page. A match will see this node marked as active.
      *
-     * This function compares the nodes url to the static var {@link navigation_node::fullmeurl}
-     * and if they match (based on $strenght) then the node is considered active.
-     *
-     * Note: This function is recursive, when you call it it will check itself and all
-     * children recursivily.
-     *
-     * @staticvar moodle_url $fullmeurl
-     * @param int $strength When using the moodle_url compare function how strictly
-     *                       to check for a match. Defaults to URL_MATCH_EXACT
-     *                       Can be URL_MATCH_EXACT or URL_MATCH_BASE
-     * @return bool True is active, false otherwise
+     * @global string $FULLME
+     * @global moodle_page $PAGE
+     * @param int $strength One of URL_MATCH_EXACT, URL_MATCH_PARAMS, or URL_MATCH_BASE
+     * @return bool
      */
     public function check_if_active($strength=URL_MATCH_EXACT) {
         global $FULLME, $PAGE;
+        // Set fullmeurl if it hasn't already been set
         if (self::$fullmeurl == null) {
             if ($PAGE->has_set_url()) {
-                $this->override_active_url(new moodle_url($PAGE->url));
+                self::override_active_url(new moodle_url($PAGE->url));
             } else {
-                $this->override_active_url(new moodle_url($FULLME));
+                self::override_active_url(new moodle_url($FULLME));
             }
         }
 
+        // Compare the action of this node against the fullmeurl
         if ($this->action instanceof moodle_url && $this->action->compare(self::$fullmeurl, $strength)) {
             $this->make_active();
             return true;
-        } else if (is_string($this->action) && $this->action==self::$fullmeurl->out()) {
-            $this->make_active();
-            return true;
         }
         return false;
     }
+
     /**
-     * This function allows the user to add a child node to this node.
+     * Overrides the fullmeurl variable providing
      *
-     * @param string $text The text to display in the node
-     * @param string $action Either a moodle_url or a bit of html to use instead of the text <i>optional</i>
-     * @param int $type The type of node should be one of the const types of navigation_node <i>optional</i>
-     * @param string $shorttext The short text to use for this node
-     * @param string|int $key Sets the key that can be used to retrieve this node <i>optional</i>
-     * @param string $icon The path to an icon to use for this node <i>optional</i>
-     * @return string The key that was used for this node
+     * @param moodle_url $url The url to use for the fullmeurl.
      */
-    public function add($text, $action=null, $type=null, $shorttext=null, $key=null, pix_icon $icon=null) {
+    public static function override_active_url(moodle_url $url) {
+        self::$fullmeurl = $url;
+    }
+
+    /**
+     * Adds a navigation node as a child of this node.
+     * 
+     * @param string $text
+     * @param moodle_url|action_link $action
+     * @param int $type
+     * @param string $shorttext
+     * @param string|int $key
+     * @param pix_icon $icon
+     * @return navigation_node
+     */
+    public function add($text, $action=null, $type=self::TYPE_CUSTOM, $shorttext=null, $key=null, pix_icon $icon=null) {
+        // First convert the nodetype for this node to a branch as it will now have children
         if ($this->nodetype !== self::NODETYPE_BRANCH) {
             $this->nodetype = self::NODETYPE_BRANCH;
         }
-        $itemarray = array('text'=>$text);
-        if ($type!==null) {
-            $itemarray['type'] = $type;
-        } else {
-            $type = self::TYPE_CUSTOM;
-        }
+        // Properties array used when creating the new navigation node
+        $itemarray = array(
+            'text' => $text,
+            'type' => $type
+        );
+        // Set the action if one was provided
         if ($action!==null) {
             $itemarray['action'] = $action;
         }
-
+        // Set the shorttext if one was provided
         if ($shorttext!==null) {
             $itemarray['shorttext'] = $shorttext;
         }
+        // Set the icon if one was provided
         if ($icon!==null) {
             $itemarray['icon'] = $icon;
         }
-        if ($key===null) {
-            $key = count($this->children);
+        // Default the key to the number of children if not provided
+        if ($key === null) {
+            $key = $this->children->count();
         }
-
-        $key = $key.':'.$type;
-
+        // Set the key
         $itemarray['key'] = $key;
-        $this->children[$key] = new navigation_node($itemarray);
+        // Set the parent to this node
+        $itemarray['parent'] = $this;
+        // Add the child using the navigation_node_collections add method
+        $node = $this->children->add(new navigation_node($itemarray));
+        // If the node is a category node or the user is logged in and its a course
+        // then mark this node as a branch (makes it expandable by AJAX)
         if (($type==self::TYPE_CATEGORY) || (isloggedin() && $type==self::TYPE_COURSE)) {
-            $this->children[$key]->nodetype = self::NODETYPE_BRANCH;
+            $node->nodetype = self::NODETYPE_BRANCH;
         }
+        // If this node is hidden mark it's children as hidden also
         if ($this->hidden) {
-            $this->children[$key]->hidden = true;
+            $node->hidden = true;
         }
-        return $key;
+        // Return the node (reference returned by $this->children->add()
+        return $node;
     }
 
     /**
-     * Adds a new node to a particular point by recursing through an array of node keys
+     * Searches for a node of the given type with the given key.
      *
-     * @param array $patharray An array of keys to recurse to find the correct node
-     * @param string $text The text to display in the node
-     * @param string|int $key Sets the key that can be used to retrieve this node <i>optional</i>
-     * @param int $type The type of node should be one of the const types of navigation_node <i>optional</i>
-     * @param string $action Either a moodle_url or a bit of html to use instead of the text <i>optional</i>
-     * @param string $icon The path to an icon to use for this node <i>optional</i>
-     * @return mixed Either the key used for the node once added or false for failure
+     * This searches this node plus all of its children, and their children....
+     * If you know the node you are looking for is a child of this node then please
+     * use the get method instead.
+     *
+     * @param int|string $key The key of the node we are looking for
+     * @param int $type One of navigation_node::TYPE_*
+     * @return navigation_node|false
      */
-    public function add_to_path($patharray, $key=null, $text=null, $shorttext=null, $type=null, $action=null, pix_icon $icon=null) {
-        if (count($patharray)==0) {
-            $key = $this->add($text, $action, $type, $shorttext, $key, $icon);
-            return $key;
-        } else {
-            $pathkey = array_shift($patharray);
-            $child = $this->get($pathkey);
-            if ($child!==false) {
-                return $child->add_to_path($patharray, $key, $text, $shorttext, $type, $action, $icon);
-            } else {
-                return false;
+    public function find($key, $type) {
+        return $this->children->find($key, $type);
             }
-        }
-    }
 
     /**
-     * Add a css class to this particular node
+     * Get ths child of this node that has the given key + (optional) type.
      *
-     * @param string $class The css class to add
-     * @return bool Returns true
+     * If you are looking for a node and want to search all children + thier children
+     * then please use the find method instead.
+     *
+     * @param int|string $key The key of the node we are looking for
+     * @param int $type One of navigation_node::TYPE_*
+     * @return navigation_node|false
      */
-    public function add_class($class) {
-        if (!in_array($class, $this->classes)) {
-            $this->classes[] = $class;
+    public function get($key, $type=null) {
+        return $this->children->get($key, $type);
         }
-        return true;
-    }
 
     /**
-     * Removes a given class from this node if it exists
+     * Removes this node.
      *
-     * @param string $class
      * @return bool
      */
-    public function remove_class($class) {
-        if (in_array($class, $this->classes)) {
-            $key = array_search($class,$this->classes);
-            if ($key!==false) {
-                unset($this->classes[$key]);
-                return true;
+    public function remove() {
+        return $this->parent->children->remove($this->key, $this->type);
             }
-        }
-        return false;
-    }
 
     /**
-     * Recurse down child nodes and collapse everything once a given
-     * depth of recursion has been reached.
+     * Checks if this node has or could have any children
      *
-     * This function is used internally during the initialisation of the nav object
-     * after the tree has been generated to collapse it to a suitable depth.
-     *
-     * @param int $depth defualts to 2
-     * @return bool Returns true
+     * @return bool Returns true if it has children or could have (by AJAX expansion)
      */
-    protected function collapse_at_depth($depth=2) {
-        if ($depth>0 && $this->nodetype===self::NODETYPE_BRANCH) {
-            foreach (array_keys($this->children) as $key) {
-                $this->children[$key]->collapse_at_depth($depth-1);
+    public function has_children() {
+        return ($this->nodetype === navigation_node::NODETYPE_BRANCH || $this->children->count()>0);
             }
-            return true;
-        } else {
-            $this->collapse_children();
-            return true;
+
+    /**
+     * Marks this node as active and forces it open.
+     */
+    public function make_active() {
+        $this->isactive = true;
+        $this->add_class('active_tree_node');
+        $this->force_open();
+        if ($this->parent !== null) {
+            $this->parent->make_inactive();
         }
     }
 
     /**
-     * Collapses all of the child nodes recursion optional
-     *
-     * @param bool $recurse If set to true child nodes are closed recursively
-     * @return bool Returns true
+     * Marks a node as inactive and recusised back to the base of the tree
+     * doing the same to all parents.
      */
-    protected function collapse_children($recurse=true) {
-        if ($this->nodetype === self::NODETYPE_BRANCH && count($this->children)>0) {
-            foreach ($this->children as &$child) {
-                if (!$this->forceopen) {
-                    $child->collapse = true;
+    public function make_inactive() {
+        $this->isactive = false;
+        $this->remove_class('active_tree_node');
+        if ($this->parent !== null) {
+            $this->parent->make_inactive();
                 }
-                if ($recurse && $child instanceof navigation_node) {
-                    $child->collapse_children($recurse);
                 }
-            }
-            unset($child);
-        }
-        return true;
-    }
 
     /**
-     * Produce the actual HTML content for the node including any action or icon
+     * Forces this node to be open and at the same time forces open all
+     * parents until the root node.
      *
-     * @param bool $shorttext If true then short text is used rather than text if it has been set
-     * @return string The HTML content
+     * Recursive.
      */
-    public function content($shorttext=false) {
-        global $OUTPUT;
-        if (!$this->display) {
-            return '';
+    public function force_open() {
+        $this->forceopen = true;
+        if ($this->parent !== null) {
+            $this->parent->force_open();
         }
-        if ($shorttext && $this->shorttext!==null) {
-            $content = format_string($this->shorttext);
-        } else {
-            $content = format_string($this->text);
         }
-        $title = '';
-        if ($this->forcetitle || ($this->shorttext!==null && $this->title !== $this->shorttext) || $this->title !== $this->text) {
-             $title = $this->title;
-        }
 
-        if ($this->icon instanceof renderable) {
-            $icon = $OUTPUT->render($this->icon);
-            $content = $icon.'&nbsp;'.$content; // use CSS for spacing of icons
-        } else if ($this->helpbutton !== null) {
-            $content = trim($this->helpbutton).html_writer::tag('span', $content, array('class'=>'clearhelpbutton'));
+    /**
+     * Adds a CSS class to this node.
+     *
+     * @param string $class
+     * @return bool
+     */
+    public function add_class($class) {
+        if (!in_array($class, $this->classes)) {
+            $this->classes[] = $class;
         }
-
-        if ($content === '') {
-            return '';
+        return true;
         }
 
-        if ($this->action instanceof action_link) {
-            //TODO: to be replaced with something else
-            $link = $this->action;
-            if ($this->hidden) {
-                $link->add_class('dimmed');
+    /**
+     * Removes a CSS class from this node.
+     *
+     * @param string $class
+     * @return bool True if the class was successfully removed.
+     */
+    public function remove_class($class) {
+        if (in_array($class, $this->classes)) {
+            $key = array_search($class,$this->classes);
+            if ($key!==false) {
+                unset($this->classes[$key]);
+                return true;
             }
-            $content = $OUTPUT->render($link);
-
-        } else if ($this->action instanceof moodle_url) {
-            $attributes = array();
-            if ($title !== '') {
-                $attributes['title'] = $title;
             }
-            if ($this->hidden) {
-                $attributes['class'] = 'dimmed_text';
+        return false;
             }
-            $content = html_writer::link($this->action, $content, $attributes);
 
-        } else if (is_string($this->action) || empty($this->action)) {
-            $attributes = array();
-            if ($title !== '') {
-                $attributes['title'] = $title;
+    /**
+     * Sets the title for this node and forces Moodle to utilise it.
+     * @param string $title
+     */
+    public function title($title) {
+        $this->title = $title;
+        $this->forcetitle = true;
             }
-            if ($this->hidden) {
-                $attributes['class'] = 'dimmed_text';
-            }
-            $content = html_writer::tag('span', $content, $attributes);
-        }
 
-        return $content;
-    }
-
     /**
-     * Get the CSS type for this node
-     *
-     * @return string
+     * Resets the page specific information on this node if it is being unserialised.
      */
-    public function get_css_type() {
-        if (array_key_exists($this->type, $this->namedtypes)) {
-            return 'type_'.$this->namedtypes[$this->type];
+    public function __wakeup(){
+        $this->forceopen = false;
+        $this->isactive = false;
+        $this->remove_class('active_tree_node');
         }
-        return 'type_unknown';
-    }
 
     /**
-     * Find and return a child node if it exists (returns a reference to the child)
+     * Checks if this node or any of its children contain the active node.
      *
-     * This function is used to search for and return a reference to a child node when provided
-     * with the child nodes key and type.
-     * If the child is found a reference to it is returned otherwise the default is returned.
+     * Recursive.
      *
-     * @param string|int $key The key of the child node you are searching for.
-     * @param int $type The type of the node you are searching for. Defaults to TYPE_CATEGORY
-     * @param mixed $default The value to return if the child cannot be found
-     * @return mixed The child node or what ever default contains (usually false)
+     * @return bool
      */
-    public function find_child($key, $type=self::TYPE_CATEGORY, $default = false) {
-        list($key, $type) = $this->split_key_type($key, $type);
-        if (array_key_exists($key.":".$type, $this->children)) {
-            return $this->children[$key.":".$type];
-        } else if ($this->nodetype === self::NODETYPE_BRANCH && count($this->children)>0 && $this->type<=$type) {
-            foreach ($this->children as &$child) {
-                $outcome = $child->find_child($key, $type);
-                if ($outcome !== false) {
-                    return $outcome;
+    public function contains_active_node() {
+        if ($this->isactive) {
+            return true;
+        } else {
+            foreach ($this->children as $child) {
+                if ($child->isactive || $child->contains_active_node()) {
+                    return true;
                 }
             }
         }
-        return $default;
+        return false;
     }
 
     /**
-     * Find the active child
+     * Finds the active node.
      *
-     * @param null|int $type
-     * @return navigation_node|bool
+     * Searches this nodes children plus all of the children for the active node
+     * and returns it if found.
+     *
+     * Recursive.
+     *
+     * @return navigation_node|false
      */
-    public function find_active_node($type=null) {
-        if ($this->contains_active_node()) {
-            if ($type!==null && $this->type===$type) {
+    public function find_active_node() {
+        if ($this->isactive) {
                 return $this;
-            }
-            if ($this->nodetype === self::NODETYPE_BRANCH && count($this->children)>0) {
-                foreach ($this->children as $child) {
-                    if ($child->isactive && !$child->contains_active_node()) {
-                        return $child;
                     } else {
-                        $outcome = $child->find_active_node($type);
-                        if ($outcome!==false) {
+            foreach ($this->children as &$child) {
+                $outcome = $child->find_active_node();
+                if ($outcome !== false) {
                             return $outcome;
                         }
                     }
                 }
-            }
-        }
         return false;
     }
 
     /**
-     * Returns the depth of a child
+     * Gets the content for this node.
      *
-     * @param string|int $key The key for the child we are looking for
-     * @param int $type The type of the child we are looking for
-     * @return int The depth of the child once found
+     * @param bool $shorttext If true shorttext is used rather than the normal text
+     * @return string
      */
-    public function find_child_depth($key, $type=self::TYPE_CATEGORY) {
-        $depth = 0;
-        list($key, $type) = $this->split_key_type($key, $type);
-        if (array_key_exists($key.':'.$type, $this->children)) {
-            $depth = 1;
-        } else if ($this->nodetype === self::NODETYPE_BRANCH && count($this->children)>0 && $this->type<=$type) {
-            foreach ($this->children as $child) {
-                $depth += $child->find_child_depth($key, $type);
+    public function get_content($shorttext=false) {
+        if ($shorttext && $this->shorttext!==null) {
+            return format_string($this->shorttext);
+        } else {
+            return format_string($this->text);
             }
         }
-        return $depth;
-    }
 
     /**
-     * Finds all nodes that have the specified type
+     * Gets the title to use for this node.
      *
-     * @param int $type One of navigation_node::TYPE_*
-     * @return array An array of navigation_node references for nodes of type $type
+     * @return string
      */
-    public function get_children_by_type($type) {
-        $nodes = array();
-        if (count($this->children)>0) {
-            foreach ($this->children as &$child) {
-                if ($child->type === $type) {
-                    $nodes[] = $child;
+    public function get_title() {
+        if ($this->forcetitle || ($this->shorttext!==null && $this->title !== $this->shorttext) || $this->title !== $this->text) {
+            return $this->title;
+        } else {
+            return '';
                 }
             }
-        }
-        return $nodes;
-    }
 
     /**
-     * Finds all nodes (recursivily) that have the specified type, regardless of
-     * assumed order or position.
+     * Gets the CSS class to add to this node to describe its type
      *
-     * @param int $type One of navigation_node::TYPE_*
-     * @return array An array of navigation_node references for nodes of type $type
+     * @return string
      */
-    public function find_children_by_type($type) {
-        $nodes = array();
-        if (count($this->children)>0) {
-            foreach ($this->children as &$child) {
-                if ($child->type === $type) {
-                    $nodes[] = $child;
+    public function get_css_type() {
+        if (array_key_exists($this->type, $this->namedtypes)) {
+            return 'type_'.$this->namedtypes[$this->type];
                 }
-                if (count($child->children)>0) {
-                    $nodes = array_merge($nodes, $child->find_children_by_type($type));
+        return 'type_unknown';
                 }
-            }
-        }
-        return $nodes;
-    }
 
     /**
-     * Toogles display of nodes and child nodes based on type
+     * Finds all nodes that are expandable by AJAX
      *
-     * If the type of a node if more than the type specified it's display property is set to false
-     * and it is not shown
-     *
-     * @param int $type
-     * @param bool $display
+     * @param array $expandable An array by reference to populate with expandable nodes.
      */
-    public function toggle_type_display($type=self::TYPE_COURSE, $display=false) {
-        if ((int)$this->type > $type) {
-            $this->display = $display;
+    public function find_expandable(array &$expandable) {
+        if (!isloggedin()) {
+            return;
         }
-        if (count($this->children)>0) {
-            foreach ($this->children as $child) {
-                $child->toggle_type_display($type, $display);
+        foreach ($this->children as &$child) {
+            if ($child->nodetype == self::NODETYPE_BRANCH && $child->children->count()==0) {
+                $child->id = 'expandable_branch_'.(count($expandable)+1);
+                $this->add_class('canexpand');
+                $expandable[] = array('id'=>$child->id,'branchid'=>$child->key,'type'=>$child->type);
             }
+            $child->find_expandable($expandable);
         }
     }
+}
 
     /**
-     * Find out if a child (or subchild) of this node contains an active node
+ * Navigation node collection
      *
-     * @return bool True if it does fales otherwise
+ * This class is responsible for managing a collection of navigation nodes.
+ * It is required because a node's unique identifier is a combination of both its
+ * key and its type.
+ *
+ * Originally an array was used with a string key that was a combination of the two
+ * however it was decided that a better solution would be to use a class that
+ * implements the standard IteratorAggregate interface.
+ *
+ * @package moodlecore
+ * @subpackage navigation
+ * @copyright 2010 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
      */
-    public function contains_active_node() {
-        if ($this->nodetype === self::NODETYPE_BRANCH && count($this->children)>0) {
-            foreach ($this->children as $child) {
-                if ($child->isactive || $child->contains_active_node()) {
-                    return true;
-                }
-            }
-        }
-        return false;
-    }
-
+class navigation_node_collection implements IteratorAggregate {
     /**
-     * Find all nodes that are expandable for this node and its given children.
+     * A multidimensional array to where the first key is the type and the second
+     * key is the nodes key.
+     * @var array
+     */
+    protected $collection = array();
+    /**
+     * An array that contains references to nodes in the same order they were added.
+     * This is maintained as a progressive array.
+     * @var array
+     */
+    protected $orderedcollection = array();
+    /**
+     * A reference to the last node that was added to the collection
+     * @var navigation_node
+     */
+    protected $last = null;
+    /**
+     * The total number of items added to this array.
+     * @var int
+     */
+    protected $count = 0;
+    /**
+     * Adds a navigation node to the collection
      *
-     * This function recursively finds all nodes that are expandable by AJAX within
-     * [and including] this child.
-     *
-     * @param array $expandable An array to fill with the HTML id's of all branches
-     * that can be expanded by AJAX. This is a forced reference.
-     * @param int $expansionlimit Optional/used internally can be one of navigation_node::TYPE_*
+     * @global stdClass $CFG
+     * @param navigation_node $node
+     * @return navigation_node
      */
-    public function find_expandable(&$expandable, $expansionlimit = null) {
-        static $branchcount;
-        if ($branchcount==null) {
-            $branchcount=1;
+    public function add(navigation_node $node) {
+        global $CFG;
+        $key = $node->key;
+        $type = $node->type;
+        // First check we have a 2nd dimension for this type
+        if (!array_key_exists($type, $this->orderedcollection)) {
+            $this->orderedcollection[$type] = array();
         }
-        if ($this->nodetype == self::NODETYPE_BRANCH && count($this->children)==0 && ($expansionlimit === null || $this->type < $expansionlimit)) {
-            $this->id = 'expandable_branch_'.$branchcount;
-            $this->add_class('canexpand');
-            $branchcount++;
-            $expandable[] = array('id'=>$this->id,'branchid'=>$this->key,'type'=>$this->type);
-        } else if ($this->nodetype==self::NODETYPE_BRANCH && ($expansionlimit === null || $this->type <= $expansionlimit)) {
-            foreach ($this->children as $child) {
-                $child->find_expandable($expandable, $expansionlimit);
+        // Check for a collision and report if debugging is turned on
+        if ($CFG->debug && array_key_exists($key, $this->orderedcollection[$type])) {
+            debugging('Navigation node intersect: Adding a node that already exists '.$key, DEBUG_DEVELOPER);
             }
+        // Add the node to the appropriate place in the ordered structure.
+        $this->orderedcollection[$type][$key] = $node;
+        // Add a reference to the node to the progressive collection.
+        $this->collection[$this->count] = &$this->orderedcollection[$type][$key];
+        // Update the last property to a reference to this new node.
+        $this->last = &$this->orderedcollection[$type][$key];
+        $this->count++;
+        // Return the reference to the now added node
+        return $this->last;
         }
-    }
 
     /**
-     * Used to return a child node with a given key
+     * Fetches a node from this collection.
      *
-     * This function searchs for a child node with the provided key and returns the
-     * child. If the child doesn't exist then this function returns false.
-     *
-     * @param int|string $key The key to search for
-     * @param int $type Optional one of TYPE_* constants
-     * @param navigation_node|bool The child if it exists or false
+     * @param string|int $key The key of the node we want to find.
+     * @param int $type One of navigation_node::TYPE_*.
+     * @return navigation_node|null
      */
     public function get($key, $type=null) {
-        if ($key===false) {
-            return false;
+        if ($type !== null) {
+            // If the type is known then we can simply check and fetch
+            if (!empty($this->orderedcollection[$type][$key])) {
+                return $this->orderedcollection[$type][$key];
         }
-        list($key, $type) = $this->split_key_type($key);
-        if ($this->nodetype === self::NODETYPE_BRANCH && count($this->children)>0) {
-            if ($type!==null) {
-                if (array_key_exists($key.':'.$type, $this->children)) {
-                    return $this->children[$key.':'.$type];
-                }
             } else {
-                foreach (array_keys($this->children) as $childkey) {
-                    if (strpos($childkey, $key.':')===0) {
-                        return $this->children[$childkey];
+            // Because we don't know the type we look in the progressive array
+            foreach ($this->collection as $node) {
+                if ($node->key === $key) {
+                    return $node;
                     }
                 }
             }
-        }
         return false;
     }
-
     /**
-     * This function is used to split a key into its key and value parts if the
-     * key is a combination of the two.
+     * Searches for a node with matching key and type.
      *
-     * Was introduced to help resolve MDL-20543
+     * This function searches both the nodes in this collection and all of
+     * the nodes in each collection belonging to the nodes in this collection.
      *
-     * @param string $key
-     * @param int|null $type
-     * @return array
-     */
-    protected function split_key_type($key, $type=null) {
-        /**
-         * If the key is a combination it will be of the form `key:type` where key
-         * could be anything and type will be an int value
-         */
-        if (preg_match('#^(.*)\:(\d{1,3})$#', $key, $match)) {
-            /**
-             * If type is null then we want to collect and return the type otherwise
-             * we will use the provided type. This ensures that if a type was specified
-             * it is not lost
-             */
-            if ($type===null) {
-                $type = $match[2];
-            }
-            $key = $match[1];
-        }
-        return array($key, $type);
-    }
-
-    /**
-     * Fetch a node given a set of keys that describe its path
+     * Recursive.
      *
-     * @param array $keys An array of keys
-     * @return navigation_node|bool The node or false
+     * @param string|int $key  The key of the node we want to find.
+     * @param int $type  One of navigation_node::TYPE_*.
+     * @return navigation_node|null
      */
-    public function get_by_path($keys) {
-        if (count($keys)==1) {
-            $key = array_shift($keys);
-            return $this->get($key);
+    public function find($key, $type=null) {
+        if ($type !== null && array_key_exists($type, $this->orderedcollection) && array_key_exists($key, $this->orderedcollection[$type])) {
+            return $this->orderedcollection[$type][$key];
         } else {
-            $key = array_shift($keys);
-            $child = $this->get($key);
-
-            if ($child !== false) {
-                return $child->get_by_path($keys);
+            $nodes = $this->getIterator();
+            // Search immediate children first
+            foreach ($nodes as &$node) {
+                if ($node->key == $key && ($type == null || $type === $node->type)) {
+                    return $node;
             }
-            return false;
         }
+            // Now search each childs children
+            foreach ($nodes as &$node) {
+                $result = $node->children->find($key, $type);
+                if ($result !== false) {
+                    return $result;
     }
-
-    /**
-     * Returns the child marked as active if there is one, false otherwise.
-     *
-     * @return navigation_node|bool The active node or false
-     */
-    public function get_active_node() {
-        foreach ($this->children as $child) {
-            if ($child->isactive) {
-                return $child;
             }
         }
         return false;
     }
 
     /**
-     * Mark this node as active
+     * Fetches the last node that was added to this collection
      *
-     * This function marks the node as active my forcing the node to be open,
-     * setting isactive to true, and adding the class active_tree_node
+     * @return navigation_node
      */
-     public function make_active() {
-        $this->forceopen = true;
-        $this->isactive = true;
-        $this->add_class('active_tree_node');
+    public function last() {
+        return $this->last;
      }
-
     /**
-     * This intense little function looks for branches that are forced open
-     * and checks to ensure that all parent nodes are also forced open.
+     * Fetches all nodes of a given type from this collection
      */
-    public function respect_forced_open() {
-        foreach ($this->children as $child) {
-            $child->respect_forced_open();
-            if ($child->forceopen) {
-                $this->forceopen = true;
+    public function type($type) {
+        if (!array_key_exists($type, $this->orderedcollection)) {
+            $this->orderedcollection[$type] = array();
             }
+        return $this->orderedcollection[$type];
         }
-    }
-
     /**
-     * This function simply removes a given child node
+     * Removes the node with the given key and type from the collection
      *
-     * @param string|int $key The key that identifies a child node
+     * @param string|int $key
+     * @param int $type
      * @return bool
      */
-    public function remove_child($key, $type=null) {
-        if ($key instanceof navigation_node) {
-            $key = $key->key;
-        }
+    public function remove($key, $type=null) {
         $child = $this->get($key, $type);
-        if ($child) {
-            unset($this->children[$child->key]);
-            return true;
+        if ($child !== false) {
+            foreach ($this->collection as $colkey => $node) {
+                if ($node->key == $key && $node->type == $type) {
+                    unset($this->collection[$colkey]);
+                    break;
         }
-        return false;
     }
-
-    /**
-     * Iterate all children and check if any of them are active
-     *
-     * This function iterates all children recursively until it sucecssfully marks
-     * a node as active, or gets to the end of the tree.
-     * This can be used on a cached branch to mark the active child.
-     *
-     * @param int $strength When using the moodle_url compare function how strictly
-     *                       to check for a match. Defaults to URL_MATCH_EXACTLY
-     * @return bool True is a node was marked active false otherwise
-     */
-    public function reiterate_active_nodes($strength=URL_MATCH_EXACT) {
-        if ($this->nodetype !== self::NODETYPE_BRANCH) {
-            return false;
-        }
-        foreach ($this->children as $child) {
-            $outcome = $child->check_if_active($strength);
-            if (!$outcome && $child->nodetype === self::NODETYPE_BRANCH) {
-                $outcome = $child->reiterate_active_nodes($strength);
-            }
-            if ($outcome) {
-                $this->forceopen = true;
+            unset($this->orderedcollection[$child->type][$child->key]);
+            $this->count--;
                 return true;
             }
+        return false;
         }
-    }
 
     /**
-     * This function sets the title for the node and at the same time sets
-     * forcetitle to true to ensure that it is used if possible
-     *
-     * @param string $title
+     * Gets the number of nodes in this collection
+     * @return int
      */
-    public function title($title) {
-        $this->title = $title;
-        $this->forcetitle = true;
+    public function count() {
+        return count($this->collection);
     }
-
     /**
-     * Magic Method: When we unserialise an object make it `unactive`
+     * Gets an array iterator for the collection.
      *
-     * This is to ensure that when we take a branch out of the cache it is not marked
-     * active anymore, as we can't be sure it still is (infact it most likely isnt)
+     * This is required by the IteratorAggregator interface and is used by routines
+     * such as the foreach loop.
+     *
+     * @return ArrayIterator
      */
-    public function __wakeup(){
-        $this->forceopen = false;
-        $this->isactive = false;
-        $this->remove_class('active_tree_node');
+    public function getIterator() {
+        return new ArrayIterator($this->collection);
     }
 }
 
